//script made with GST-Builder from www.gstools.de
//------------------------------------------------------------------
// Name: GSTNet
// Creator: nfs42 gstools.de
// purpose: definitions for GSTNet.dll, a socket based
//          multiplayer plugin for 3DGS > 6.xx 
//------------------------------------------------------------------
// version: 0.7.2.1
// 081228  - _Init() no need for :-)
// version: 0.7.2
// 081227  + event GSTNet_EvTypeLogin
//         x _GetGlobal only field as input returns string pointer
//         + _Init initializing strings !!?
// version: 0.7.1
// 081213  + event GSTNet_EvTypeVar
//         + event GSTNet_EvTypeString
// version: 0.7
// 081201  x _ClientPoll no parameters anymore
//         x _ServerPoll no parameters any more
//         - _ServerSendGlobal
//         + _SendGlobals
// 081123  + _GetPlayerId
//         + _WritePlayer
//         + _ReadPlayer
//         + _LoginPlayer
//         + _VerifyPlayer
// 081122  + _SetPlayerValue
//         + _GetPlayerValue
//         + _SendPlayerValues
//         + _SynchronizePlayerValues
// version: 0.6.0
// 081121  + _SetSendMode
//         + _GetSendMode
// 0801116 + _Compatibility
// version: 0.5.25
// 080513  +_ServerSetGlobal
//         +_ServerGetGlobal
//         +_ServerSendGlobal
//         ^_SynchronizeSkills
// 080512  x_StartClient intervall is now used for tracking in seconds
//         x_StartServer intervall is now used for tracking in seconds
// 080511  +_SetTrackIntervall >0 frames; <0 seconds
//         +_GetTrackIntervall >0 frames; <0 seconds
//         +_GetTimestamp
//         +_ServerSendFile
//         +_EvTypeFile
// version: 0.5.24
// 080507  x_Synchronize(mode)
// 080507  +_SynchronizeEntity
// 080507  +_SynchronizeSkills
// 080507  +defines for synchronization
// 080130  +_ent_createlocal
// 071117  xdefine GSTNet to GSTNET
// 070907  +_Stats + defines
// 070820  +_ClientIP, _MyIP
// 070819  +_CryptString
// 070729  +_TrackString
// 070718  +_SendArray
// 070715: +_SendEntity
//         -_UpdateEntity
//         +_SendSkills
//         -_UpdateSkills
// 070708: +_Disconnect
//         -_exit()
// version: 0.43 beta
//   + GSTNet_UntrackSkills
//   + GSTNet_ent_morph(entity, filename);
// version: 0.42 beta
//   + GSTNet_TrackSkills
//   + GSTNet_UpdateEntity

// version: 0.41 beta
//   + GSTNet_TrackSkills
// version: 0.4 beta
//   + GSTNet_Events
//   + GSTNet_TrackEntity
//   + GSTNet_effect
//------------------------------------------------------------------

 
ifndef GSTNET;
define GSTNET;

//------------------------------------------------------------------
//   system functions
//------------------------------------------------------------------
dllfunction GSTNet_ServerInit(port);          //initialize server engine
dllfunction GSTNet_ServerPoll();              //poll server packets
dllfunction GSTNet_Disconnect(vId);           // disconnects client from server (kick client)
dllfunction GSTNet_ClientIP(vId,sIP);         // get the ip of the given client
dllfunction GSTNet_MyIP(sIP1,sIP2,sIP3,sIP4); // get the ips of the own running system
dllfunction GSTNet_ClientInit(ip, port);      // initialize client engine
dllfunction GSTNet_ClientPoll();              // poll client packets
dllfunction GSTNet_ClientSend(vReceiver, vType, sMessage); // send a client packet
dllfunction GSTNet_ServerSend(vReceiver, vType, sMessage); // send a server packet
dllfunction GSTNet_ServerSendFile(vReceiver, vType, sFile); // send a server packet
dllfunction GSTNet_TrackVar(sName);             // tracks a var on server and send it to all clients if changed
dllfunction GSTNet_TrackString(sName);          // tracks a var on server and send it to all clients if changed
dllfunction GSTNet_SendVar(vReceiver,sName);    // send a var to all clients
dllfunction GSTNet_SendArray(vReceiver,sName, vFrom, vTo); // send a part of a var array  to all clients
dllfunction GSTNet_SendString(vReceiver, sName);           // send a string to all clients
dllfunction GSTNet_effect(functionname, number, &position, &speed);  // create a global effect on all clients
dllfunction GSTNet_Synchronize(mode);               // sync client with server
dllfunction GSTNet_SynchronizeEntity(entity,properties);         // single ent property sync client with server
dllfunction GSTNet_SynchronizeSkills(entity, fromSkill, toSkill); // single ent skill sync client with server
dllfunction GSTNet_Version(sVersion);           // get GSTNet version
dllfunction GSTNet_Timestamp();           // returns GSTNet timestamp in seconds
dllfunction GSTNet_SetGlobal(sField, sValue); // send a server variable, returns pointer to string value
dllfunction GSTNet_GetGlobal(sField); // get a server variable
dllfunction GSTNet_SendGlobals(vReceiver, sField); // send a server variable
dllfunction GSTNet_ReadGlobals(sFile); // reads server globals from file
dllfunction GSTNet_WriteGlobals(sFile); // writes server globals to file
dllfunction GSTNet_SendGlobals(vReceiver, sField); // send a server variable
dllfunction GSTNet_Compatibility(vMode);           // vMode >0 for c-script
dllfunction GSTNet_SetSendMode(vMode);           // vMode >0 for c-script
dllfunction GSTNet_GetSendMode();           // returns actual SendMode
dllfunction GSTNet_SetVerifyKey(sMagicKey); // sets the key for verifying data transfer between client+server
//------------------------------------------------------------------
//   player functions
//------------------------------------------------------------------
dllfunction GSTNet_SetPlayerValue(vClientid, sField, sValue); // set a player value
dllfunction GSTNet_GetPlayerValue(vClientid, sField, sValue); // get a player value
dllfunction GSTNet_SendPlayerValues(vReceiver, vClientid, sFields); // send a player value
dllfunction GSTNet_SynchronizePlayerValues(vClientid, sFields); // synchronize a player value
dllfunction GSTNet_WritePlayer(vClientId, sFile); // write globals to sFile
dllfunction GSTNet_ReadPlayer(vClientId, sFile); // read globals from sFile
dllfunction GSTNet_LoginPlayer( sPlayername,  sPassword); // read globals from sFile
dllfunction GSTNet_VerifyPlayer(vClientId); // verifies a player login
dllfunction GSTNet_GetPlayerId(sPlayername); // returns the clientid of the given player or 0



//dllfunction GSTNet_KeepAlive(vSecs);          // keeps client alive on server

//------------------------------------------------------------------
//   entity functions
//------------------------------------------------------------------
dllfunction GSTNet_ent_create(filename,&vector,eventfunction); // create a global entity on all clients
dllfunction GSTNet_ent_createlocal(filename,&vector,eventfunction); // create a local entity
dllfunction GSTNet_ent_remove(entity);                         // remove a global entity on all clients
dllfunction GSTNet_ent_morph(entity, filename);                         // morphs a global entity on all clients
dllfunction GSTNet_TrackEntity(entity, properties);   // track a global entity on all clients
dllfunction GSTNet_UntrackEntity(entity, properties);   // track a global entity on server and it to all clients if changed
dllfunction GSTNet_TrackSkills(entity, fromskill, toskill);   // track skills of a global entity on all clients
dllfunction GSTNet_SetTrackIntervall(vSeconds);   // intervall tracks were sent
dllfunction GSTNet_GetTrackIntervall();   // returns actual track intervall in seconds
dllfunction GSTNet_SendEntity(vReceiver, entity, properties);   // send a global entity to all clients from any entity on any client or server to all
dllfunction GSTNet_SendSkills(vReceiver, entity, fromskill, toskill);   // sends skills of a global entity from server to all clients
dllfunction GSTNet_Handle(entity); //returns global handle
dllfunction GSTNet_PtrForHandle(handle); //returns entity from global handle
dllfunction GSTNet_RegisterEntity(entity); //register a wed created entity on server and all clients
//------------------------------------------------------------------
// info functions
//------------------------------------------------------------------
dllfunction GSTNet_CreatorId(entity); // returns creator of the given entity
dllfunction GSTNet_SetCreatorId(entity,id); // sets creator of the given entity

dllfunction GSTNet_ClientId();        // returns an unique id created by the server
dllfunction GSTNet_ClientsConnected();// returns the actual connected clients 
dllfunction GSTNet_Connection();        // returns 0=no, 1=server 2=client 3=client+server
dllfunction GSTNet_Ping();        // returns the last roundtriptime from sending
                                  // a reliable packet to its acknowledgement
dllfunction GSTNet_Stats(vPara);  // returns various statistic info

//------------------------------------------------------------------
// event functions
//------------------------------------------------------------------
dllfunction GSTNet_Events(type,funcname); // set eventfunction for server/client and user events
define GSTNet_EventServer = 1;
define GSTNet_EventClient = 2;
define GSTNet_EventFunction = 3;
//system event types
define GSTNet_EvTypeConnect = 4;  // only on server
define GSTNet_EvTypeDisconnect = 5; // only on server
define GSTNet_EvTypeFile = 6; // only on server
define GSTNet_EvTypeVar = 8;
define GSTNet_EvTypeString = 9;
define GSTNet_EvTypeData = 10;
 

//------------------------------------------------------------------
// helper functions
//------------------------------------------------------------------
dllfunction GSTNet_CryptString(sSrc,sDest); // en-/decrypts a string
dllfunction GSTNet_CryptFile(sSrcFilename,sDestFilename); // en-/decrypts a file
dllfunction GSTNet_HTTPGetFile(sHostname,sPath,sFilename); //saves a requested http file to disk 
dllfunction GSTNet_HTTPGet(sHostname,sPath,sResult); // returns a requested page
dllfunction GSTNet_HTTPPost(sHostname,sPath,sData,sResult); // BETA returns a requested page
dllfunction GSTNet_HTTPBusy(); // returns != 0 if a httprequest is busy
dllfunction GSTNet_Debug(vMode);  // 0:disables(default) 1: enables logging via acklog,txt
dllfunction GSTNet_Dump();    // dumps entity info to acklog.txt
on_d=GSTNet_Dump;             // do this for key 'd'

//------------------------------------------------------------------
// defines for dllfunction GSTNet_TrackEntity and GSTNet_UpdateEntity and GSTNet_SynchronizeEntity;
define GSTNet_TrackPos = 1;
define GSTNet_TrackAngle = 2;
define GSTNet_TrackScale = 4;
define GSTNet_TrackFlags = 8;
define GSTNet_TrackFrame = 16;
define GSTNet_TrackSkin = 32;
define GSTNet_TrackAmbient = 64;
define GSTNet_TrackAlbedo = 128;
define GSTNet_TrackAlpha = 256;
define GSTNet_TrackLightrange = 512;
define GSTNet_TrackColor = 1024;
define GSTNet_Trackemask = 2048;
define GSTNet_Trackeflags = 4096;
define GSTNet_TrackCollisionInfo = 8192;
//define GSTNet_TrackStrings = 16384;         // not implemented yet
//define GSTNet_TrackUndefined = 32768;          // not implemented yet
define GSTNet_TrackAll = 65535;
//------------------------------------------------------------------

//------------------------------------------------------------------
// defines for dllfunction GSTNet_Stats
define GSTNet_StatsPassedTime 1;
define GSTNet_StatsRecvBytes 2;
define GSTNet_StatsRecvBytesPerSecond 3;
define GSTNet_StatsSendBytes 4;
define GSTNet_StatsSendBytesPerSecond 5;

//------------------------------------------------------------------
// defines for dllfunction GSTNet_Synchronize;
define GSTNet_SyncEntities = 1;
define GSTNet_SyncEntityProperties = 2;
define GSTNet_SyncEntitySkills = 4;
//define GSTNet_SyncVars = 8; //only server side tracked vars 
//define GSTNet_SyncStrings = 16; //only server side tracked strings
define GSTNet_SyncAll = 65535;
//------------------------------------------------------------------
// defines for dllfunction GSTNet_SetSendMode
define GSTNet_SendUnreliable ;
define GSTNet_SendReliable ;
//------------------------------------------------------------------

//------------------------------------------------------------------
// various var/string definitions
var_nsave GSTNetId = 0;
string GSTNetMessage[256];
string 	sGSTNetTemp[256];
string 	sGSTNetTemp1[256];
string 	sGSTNetTemp2[256];
string 	sGSTNetTemp3[256];
string 	sGSTNetTemp4[256];
string 	sGSTNetTemp[256];



//------------------------------------------------------------------
// starts client engine
// input: ip : ip-address of the server i.e. "127.0.0.1"
// input: port port used by the server, normally: 2300-2400
// input: intervall : defines number of frames to wait before the
//                    next packets are polled: default 1  
//------------------------------------------------------------------
function GSTNet_StartClient(ip, port, intervall) {

  GSTNet_ClientInit(ip,port);
  GSTNet_SetTrackIntervall(intervall);

  GSTNet_Version(sGSTNetTemp);
  diag("\nGSTNet-Version:");
  diag(sGSTNetTemp);
  
  while (GSTNet_ClientId() <= 0) {
    GSTNet_ClientPoll();
    wait(1);
  }
  GSTNet_Synchronize(GSTNet_SyncAll);
  wait(-0.5);
  GSTNetId = GSTNet_ClientId();
  str_for_num(sGSTNetTemp, GSTNet_ClientId());
  diag("\nMy GSTNetId: ");
  diag(sGSTNetTemp);
  while(1) { 
    GSTNet_ClientPoll();
    wait(1);
  }
}

//------------------------------------------------------------------
// starts server engine
// input: port : port used by the server, normally: 2300-2400
// input: intervall : defines number of frames to wait before the
//                      next packets are polled: default 1  
//------------------------------------------------------------------
function GSTNet_StartServer(port, intervall) {
    GSTNet_ServerInit(port);
    GSTNet_SetTrackIntervall(intervall);
    while(1) {
      GSTNet_ServerPoll();
      wait(1);
    }
}
//------------------------------------------------------------------


//------------------------------------------------------------------
// Parse a string sent by Send_Function over the net and
// execute the function
// input:  str :string encoded by Send_Function
//------------------------------------------------------------------
function Parse_Function(str)
{
	
	var tmp_var1;
	var tmp_var2;
	var tmp_var3;
	var tmp_var4;

	var i;
	var l;
  diag("\nParse:"); diag(str);
	str_for_num(sGSTNetTemp4, 9);
		// zerstckel die nachricht
		while(i<4)
		{
			str_cpy(sGSTNetTemp,str); // schreibe den aktuellen string in den bearbeitungsstring
			temp = str_stri (str, sGSTNetTemp4); // frage nach wo das erste "und" zeichen auftaucht.
			l = str_len(sGSTNetTemp); // ermittle die lnge des strings.
			if (l==0) {return;}
			if(i!=3){str_trunc (sGSTNetTemp, l-temp+1);} // sollte es nicht der letzte durchgang sein dann clipe das ende des strings ab um die bentigte infos zu bekommen
			if(i==0){str_cpy(sGSTNetTemp1,sGSTNetTemp);} // funktionsname
			if(i==1){str_cpy(sGSTNetTemp2,sGSTNetTemp);} // inhalt
			if(i==2){tmp_var1 = str_to_num (sGSTNetTemp);} // variable1
			if(i==3){tmp_var2 = str_to_num (sGSTNetTemp);}// variable2
			str_clip(str,temp); // letzendlich clippe den anfang des strings weg, damit beim nchsten durchgang der nchste wert abgefragt wird.
			i+=1; // nchster durchgang
		}
		str_cpy(sGSTNetTemp3,sGSTNetTemp1); // flle den execute_string
		str_cat(sGSTNetTemp3," ("); //setze eine klammer 
		str_cat(sGSTNetTemp3,"\""); //anfhrungsstriche
		str_cat(sGSTNetTemp3,sGSTNetTemp2); // der string
		str_cat(sGSTNetTemp3,"\""); //anfhrungsstriche
		str_cat(sGSTNetTemp3,","); //setze ein komma
		str_for_num (sGSTNetTemp4, tmp_var1); // wandel die var wieder in einen string
		str_cat(sGSTNetTemp3,sGSTNetTemp4); //erster wert
		str_cat(sGSTNetTemp3,","); //setze ein komma
		str_for_num (sGSTNetTemp4, tmp_var2); // wandel die var wieder in einen string
		str_cat(sGSTNetTemp3,sGSTNetTemp4); //zweiter wert
		str_cat(sGSTNetTemp3,")"); //ende des execute_string
    
    str_trunc (sGSTNetTemp1, 3);
    if (str_stri(sGSTNetTemp1, "GSTNet") == 0) { return; }
		execute(sGSTNetTemp3);
		return;
}

//------------------------------------------------------------------
// send a script function over the net
// with one string and two var parameters
// input: sFunc : name of the script function
// input: sMsg : string parameter to sent
// input: vPar1 : var parameter to sent
// input: vPar2 : var parameter to sent
//------------------------------------------------------------------
function Send_Function(sFunc,sMsg,vPar1,vPar2)
{
	str_for_num(sGSTNetTemp4, 9);
	str_cpy(sGSTNetTemp1,sFunc);
	str_cat(sGSTNetTemp1,sGSTNetTemp4);
	str_cat(sGSTNetTemp1,sMsg);
	str_cat(sGSTNetTemp1,sGSTNetTemp4);
	str_for_num(sGSTNetTemp2,vPar1);
	str_cat(sGSTNetTemp1,sGSTNetTemp2);
	str_cat(sGSTNetTemp1,sGSTNetTemp4);
	str_for_num(sGSTNetTemp2,vPar2);
	str_cat(sGSTNetTemp1,sGSTNetTemp2);
	GSTNet_ClientSend(0, GSTNet_EventFunction, sGSTNetTemp1);
}
//------------------------------------------------------------------

endif; // ifndef GSTNet;